package login.page;


import javax.swing.JOptionPane;


/**
 * Author: Ismail Alson Ali Rasheed (S2000811)
 * Date Created: 01.12.2021
 * Date Last Modified: 
 
 *  Class Name: Registration
 *  Inherits the class: javax.swing.JDialog
 * 
 *  Description: Deals with Registration for new users. The user inputs various details 
 *               into the GUI, which are then evaluated for errors using different methods.
 *               Then, these are stored in a CSV file.
*/


public class Registration extends javax.swing.JDialog implements ClassObjects {
        
    public final String ACCOUNT_DETAILS_PATH = "AccountDetails.txt";

    /**
     * Creates new form Registration
     */
    public Registration(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setLocationRelativeTo(parent); //sets the frame to to the parent (Login)
        initialDepositLabel.setVisible(false);
        initialDepositField.setVisible(false);
  
        invalidFieldLabel1.setText("Invalid Format!");
        invalidFieldLabel2.setText("Invalid Format!");
        invalidFieldLabel3.setText("Invalid Format!");
        invalidFieldLabel4.setText("Invalid Format!");
        invalidFieldLabel5.setText("Invalid Format!");
        invalidFieldLabel6.setText("Invalid Format!");
        invalidFieldLabel7.setText("Invalid Format!");
        invalidFieldLabel8.setText("Invalid Format!");
        invalidFieldLabel9.setText("Invalid Format!");
        
        invalidFieldLabel1.setVisible(false);
        invalidFieldLabel2.setVisible(false);
        invalidFieldLabel3.setVisible(false);
        invalidFieldLabel4.setVisible(false);
        invalidFieldLabel5.setVisible(false);
        invalidFieldLabel6.setVisible(false);
        invalidFieldLabel7.setVisible(false);
        invalidFieldLabel8.setVisible(false);
        invalidFieldLabel9.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel24 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        completeRegistrationButton = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        cancelButton = new javax.swing.JButton();
        jLabel23 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        firstNameField = new javax.swing.JTextField();
        lastNameField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        usernameField = new javax.swing.JTextField();
        emailAddressField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        primaryContactNumberField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        secondaryContactNumberField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        passwordField = new javax.swing.JPasswordField();
        passwordConfirmationField = new javax.swing.JPasswordField();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        invalidFieldLabel1 = new javax.swing.JLabel();
        jLabelLastName = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabelEmailAddress = new javax.swing.JLabel();
        jLabelContactNum1 = new javax.swing.JLabel();
        jLabelContactNum2 = new javax.swing.JLabel();
        jLabelPassword = new javax.swing.JLabel();
        jLabelUsername = new javax.swing.JLabel();
        jLabelConfirmPassword = new javax.swing.JLabel();
        jLabelPasswordMatch = new javax.swing.JLabel();
        accountTypeField = new javax.swing.JComboBox<>();
        jLabel17 = new javax.swing.JLabel();
        initialDepositLabel = new javax.swing.JLabel();
        initialDepositField = new javax.swing.JTextField();
        chooseAccountLabel = new javax.swing.JLabel();
        invalidFieldLabel4 = new javax.swing.JLabel();
        invalidFieldLabel7 = new javax.swing.JLabel();
        emptyFieldLabel3 = new javax.swing.JLabel();
        invalidFieldLabel3 = new javax.swing.JLabel();
        invalidFieldLabel5 = new javax.swing.JLabel();
        invalidFieldLabel6 = new javax.swing.JLabel();
        invalidFieldLabel2 = new javax.swing.JLabel();
        invalidFieldLabel9 = new javax.swing.JLabel();
        invalidFieldLabel8 = new javax.swing.JLabel();

        jLabel24.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel24.setForeground(new java.awt.Color(255, 0, 0));
        jLabel24.setText("* must be maldivian number (7 digits)");

        jLabel26.setText(".");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(0, 153, 153));
        jPanel1.setForeground(new java.awt.Color(0, 153, 153));

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Registration");

        jPanel2.setBackground(new java.awt.Color(51, 255, 255));
        jPanel2.setForeground(new java.awt.Color(153, 255, 255));

        completeRegistrationButton.setBackground(new java.awt.Color(51, 255, 255));
        completeRegistrationButton.setForeground(new java.awt.Color(0, 0, 0));
        completeRegistrationButton.setText("Complete Registration");
        completeRegistrationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                completeRegistrationButtonActionPerformed(evt);
            }
        });

        jLabel13.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel13.setForeground(new java.awt.Color(255, 0, 0));
        jLabel13.setText("*");

        jLabel14.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel14.setForeground(new java.awt.Color(255, 0, 0));
        jLabel14.setText("* ");

        jLabel15.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel15.setForeground(new java.awt.Color(255, 0, 0));
        jLabel15.setText("*Must contain between 6-15 alphanumeric characters");

        jLabel16.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel16.setForeground(new java.awt.Color(255, 0, 0));
        jLabel16.setText("*Must be 7 digits");

        jLabel18.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel18.setForeground(new java.awt.Color(255, 0, 0));
        jLabel18.setText("* Required");

        jLabel19.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel19.setForeground(new java.awt.Color(255, 0, 0));
        jLabel19.setText("* Required");

        jLabel20.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel20.setForeground(new java.awt.Color(255, 0, 0));
        jLabel20.setText("* Must be alphanumerical of 10-15 characters");

        jLabel21.setFont(new java.awt.Font("Dialog", 1, 10)); // NOI18N
        jLabel21.setForeground(new java.awt.Color(255, 0, 0));
        jLabel21.setText("A Bank ID will be provided for you after the registration is completed");

        jLabel22.setFont(new java.awt.Font("Dialog", 1, 10)); // NOI18N
        jLabel22.setForeground(new java.awt.Color(255, 0, 0));
        jLabel22.setText("By registering, you agree to the Terms and Conditions of our bank");

        cancelButton.setBackground(new java.awt.Color(51, 255, 255));
        cancelButton.setForeground(new java.awt.Color(0, 0, 0));
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel23.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel23.setForeground(new java.awt.Color(255, 0, 0));
        jLabel23.setText("*Must be 7 digits");

        jLabel25.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel25.setForeground(new java.awt.Color(255, 0, 0));
        jLabel25.setText("ex: 7333333");

        jLabel30.setFont(new java.awt.Font("Dialog", 3, 10)); // NOI18N
        jLabel30.setForeground(new java.awt.Color(255, 0, 0));
        jLabel30.setText("* Required");

        jLabel2.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(0, 0, 0));
        jLabel2.setText("First Name");

        jLabel4.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel4.setForeground(new java.awt.Color(0, 0, 0));
        jLabel4.setText("Last Name");

        firstNameField.setBackground(new java.awt.Color(255, 255, 255));
        firstNameField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        firstNameField.setForeground(new java.awt.Color(0, 0, 0));
        firstNameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                firstNameFieldActionPerformed(evt);
            }
        });

        lastNameField.setBackground(new java.awt.Color(255, 255, 255));
        lastNameField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        lastNameField.setForeground(new java.awt.Color(0, 0, 0));
        lastNameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lastNameFieldActionPerformed(evt);
            }
        });

        jLabel5.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel5.setForeground(new java.awt.Color(0, 0, 0));
        jLabel5.setText("Username");

        usernameField.setBackground(new java.awt.Color(255, 255, 255));
        usernameField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        usernameField.setForeground(new java.awt.Color(0, 0, 0));
        usernameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                usernameFieldActionPerformed(evt);
            }
        });

        emailAddressField.setBackground(new java.awt.Color(255, 255, 255));
        emailAddressField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        emailAddressField.setForeground(new java.awt.Color(0, 0, 0));
        emailAddressField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                emailAddressFieldActionPerformed(evt);
            }
        });

        jLabel8.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel8.setForeground(new java.awt.Color(0, 0, 0));
        jLabel8.setText("Email Address");

        primaryContactNumberField.setBackground(new java.awt.Color(255, 255, 255));
        primaryContactNumberField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        primaryContactNumberField.setForeground(new java.awt.Color(0, 0, 0));
        primaryContactNumberField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                primaryContactNumberFieldActionPerformed(evt);
            }
        });

        jLabel7.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel7.setForeground(new java.awt.Color(0, 0, 0));
        jLabel7.setText("Contact No.1");

        secondaryContactNumberField.setBackground(new java.awt.Color(255, 255, 255));
        secondaryContactNumberField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        secondaryContactNumberField.setForeground(new java.awt.Color(0, 0, 0));
        secondaryContactNumberField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                secondaryContactNumberFieldActionPerformed(evt);
            }
        });

        jLabel9.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel9.setForeground(new java.awt.Color(0, 0, 0));
        jLabel9.setText("Contact No.2");

        passwordField.setBackground(new java.awt.Color(255, 255, 255));
        passwordField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        passwordField.setForeground(new java.awt.Color(0, 0, 0));
        passwordField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                passwordFieldActionPerformed(evt);
            }
        });

        passwordConfirmationField.setBackground(new java.awt.Color(255, 255, 255));
        passwordConfirmationField.setFont(new java.awt.Font("Dialog", 0, 16)); // NOI18N
        passwordConfirmationField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                passwordConfirmationFieldActionPerformed(evt);
            }
        });

        jLabel11.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel11.setForeground(new java.awt.Color(0, 0, 0));
        jLabel11.setText("Password");

        jLabel12.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel12.setForeground(new java.awt.Color(0, 0, 0));
        jLabel12.setText("Choose Account Type");

        invalidFieldLabel1.setText("Invalid Input!");

        jLabelLastName.setText(".");

        jLabel10.setText(".");

        jLabelEmailAddress.setText(".");

        jLabelContactNum1.setText(".");

        jLabelContactNum2.setText(".");

        jLabelPassword.setText(".");

        jLabelUsername.setText(".");

        jLabelConfirmPassword.setText(".");

        jLabelPasswordMatch.setText(".");

        accountTypeField.setBackground(new java.awt.Color(255, 255, 255));
        accountTypeField.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "-", "Current Account", "Savings Account" }));
        accountTypeField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                accountTypeFieldActionPerformed(evt);
            }
        });

        jLabel17.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        jLabel17.setForeground(new java.awt.Color(0, 0, 0));
        jLabel17.setText("Password (repeat)");

        initialDepositLabel.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        initialDepositLabel.setForeground(new java.awt.Color(0, 0, 0));
        initialDepositLabel.setText("Enter Initial Deposit");

        initialDepositField.setBackground(new java.awt.Color(255, 255, 255));
        initialDepositField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                initialDepositFieldActionPerformed(evt);
            }
        });

        chooseAccountLabel.setText("Choose Type");

        invalidFieldLabel4.setText("Invalid Input!");

        invalidFieldLabel7.setText("Invalid Input!");

        emptyFieldLabel3.setText("Empty Field!");

        invalidFieldLabel3.setText("Invalid Input!");

        invalidFieldLabel5.setText("Invalid Input!");

        invalidFieldLabel6.setText("Invalid Input!");

        invalidFieldLabel2.setText("Invalid Input!");

        invalidFieldLabel9.setText("Invalid Input!");

        invalidFieldLabel8.setText("Invalid Input!");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(initialDepositLabel)
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel12)
                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel17)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel9)
                                    .addComponent(jLabel11))))
                        .addGap(22, 22, 22)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(passwordField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(secondaryContactNumberField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(emailAddressField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(primaryContactNumberField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(firstNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(usernameField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(lastNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(passwordConfirmationField, javax.swing.GroupLayout.DEFAULT_SIZE, 160, Short.MAX_VALUE)
                                    .addComponent(accountTypeField, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel16)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(invalidFieldLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelContactNum2, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                    .addComponent(jLabel18, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
                                                    .addComponent(jLabel19, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(invalidFieldLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                                        .addComponent(invalidFieldLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addGap(18, 18, 18)
                                                        .addComponent(jLabelLastName, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel15)
                                                .addGap(12, 12, 12)
                                                .addComponent(invalidFieldLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelUsername, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel13, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                                        .addGap(280, 280, 280)
                                                        .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addContainerGap())))
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel20)
                                                .addGap(4, 4, 4)
                                                .addComponent(invalidFieldLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(invalidFieldLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelConfirmPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addComponent(chooseAccountLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                                        .addComponent(jLabel30, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(invalidFieldLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                                        .addComponent(jLabel23)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(invalidFieldLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelEmailAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(237, 237, 237)
                                                .addComponent(emptyFieldLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(224, 224, 224)
                                                .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabelContactNum1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                        .addGap(0, 0, Short.MAX_VALUE))))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(initialDepositField, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(invalidFieldLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(410, 410, 410)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(cancelButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(completeRegistrationButton))
                            .addComponent(jLabel22)
                            .addComponent(jLabel21))
                        .addContainerGap())))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(199, 199, 199)
                .addComponent(jLabelPasswordMatch, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel13)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(firstNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel18)
                                    .addComponent(jLabel2)
                                    .addComponent(invalidFieldLabel1))
                                .addGap(20, 20, 20)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(lastNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel19)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabelLastName)
                                    .addComponent(invalidFieldLabel2))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(usernameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel15)
                                    .addComponent(jLabel10)
                                    .addComponent(jLabelUsername)
                                    .addComponent(invalidFieldLabel3))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(emailAddressField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel30)
                                    .addComponent(jLabelEmailAddress)
                                    .addComponent(invalidFieldLabel4))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(primaryContactNumberField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel25)
                                    .addComponent(jLabelContactNum1)
                                    .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(emptyFieldLabel3)
                                    .addComponent(invalidFieldLabel5))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(secondaryContactNumberField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel9)
                                    .addComponent(jLabel16)
                                    .addComponent(jLabelContactNum2)
                                    .addComponent(invalidFieldLabel6))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(passwordField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel11)
                                    .addComponent(jLabel20)
                                    .addComponent(jLabelPassword)
                                    .addComponent(invalidFieldLabel7))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(passwordConfirmationField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelConfirmPassword)
                                    .addComponent(jLabel17)
                                    .addComponent(invalidFieldLabel8))))
                        .addGap(12, 12, 12)
                        .addComponent(jLabelPasswordMatch)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(accountTypeField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(chooseAccountLabel))
                                    .addComponent(jLabel12))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(invalidFieldLabel9))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(completeRegistrationButton)
                                    .addComponent(cancelButton))
                                .addGap(27, 27, 27))))
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(initialDepositField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(initialDepositLabel)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 25, Short.MAX_VALUE)
                .addComponent(jLabel21)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel22)
                .addGap(60, 60, 60)
                .addComponent(jLabel14))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addComponent(jLabel1)
                .addContainerGap(639, Short.MAX_VALUE))
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 792, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void firstNameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_firstNameFieldActionPerformed
    }//GEN-LAST:event_firstNameFieldActionPerformed

    private void lastNameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lastNameFieldActionPerformed
    }//GEN-LAST:event_lastNameFieldActionPerformed

    private void usernameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_usernameFieldActionPerformed
    }//GEN-LAST:event_usernameFieldActionPerformed

    private void primaryContactNumberFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_primaryContactNumberFieldActionPerformed
    }//GEN-LAST:event_primaryContactNumberFieldActionPerformed

    private void secondaryContactNumberFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_secondaryContactNumberFieldActionPerformed
    }//GEN-LAST:event_secondaryContactNumberFieldActionPerformed

    private void emailAddressFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_emailAddressFieldActionPerformed
    }//GEN-LAST:event_emailAddressFieldActionPerformed

    private void passwordFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_passwordFieldActionPerformed
    }//GEN-LAST:event_passwordFieldActionPerformed

    private void passwordConfirmationFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_passwordConfirmationFieldActionPerformed
    }//GEN-LAST:event_passwordConfirmationFieldActionPerformed

    private void completeRegistrationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_completeRegistrationButtonActionPerformed

        //Variables to validate and store user details. 
        String firstName = null, lastName = null, emailAddress = null, password = null; 
        Integer contactNumber = null;
        String firstPassword = null, confirmPassword = null;

        Integer error1 = null, error2 = null, error3 = null;

        //validate first name
        error1 = validateDetails.checkFieldEmpty(firstNameField.getText().isEmpty(), invalidFieldLabel1);
        error2 = validateDetails.checkContentsAreLetters(firstNameField.getText().matches("^[ A-Za-z]+$"), invalidFieldLabel1);
        firstName = validateDetails.checkTotalErrors(error1, error2, firstName,firstNameField.getText()); //set firstname if no error present
        System.out.println("First Name: " + firstName);

        //validate last name
        error1 = validateDetails.checkFieldEmpty(lastNameField.getText().isEmpty(), invalidFieldLabel2);
        error2 = validateDetails.checkContentsAreLetters(lastNameField.getText().matches("^[ A-Za-z]+$"), invalidFieldLabel2);
        lastName = validateDetails.checkTotalErrors(error1, error2, lastName,lastNameField.getText()); 
        System.out.println("Last Name: " + lastName);
        
        //validate email address 
        error1 = validateDetails.checkFieldEmpty(emailAddressField.getText().isEmpty(), invalidFieldLabel4);
        error2 = validateDetails.checkContentsAreStrings(emailAddressField.getText().matches("^[a-zA-Z0-9_@.]*$"), invalidFieldLabel4);
        emailAddress = validateDetails.checkTotalErrors(error1, error2, emailAddress,emailAddressField.getText());
        System.out.println("Email Address: " + emailAddress);
        
        //validate contact number
        error1 = validateDetails.checkFieldEmpty(primaryContactNumberField.getText().isEmpty(), invalidFieldLabel5);
        error2 = validateDetails.checkContentsAreNumbers(primaryContactNumberField.getText().matches("[0-9]+"), invalidFieldLabel5);
        error3 = validateDetails.checkContactCharacterRange(primaryContactNumberField.getText(), invalidFieldLabel5);
        contactNumber = validateDetails.checkTotalErrors(error1, error2, error3, contactNumber, primaryContactNumberField.getText()); 
        System.out.println("Primary Contact Number: " + contactNumber);

        //validate password 
        error1 = validateDetails.checkFieldEmpty(passwordField.getText().isEmpty(), invalidFieldLabel7);
        error2 = validateDetails.checkContentsAreStrings(passwordField.getText().matches("^[A-Za-z0-9@!#$&-_]*$"), invalidFieldLabel7);
        error3 = validateDetails.checkPasswordCharacterRange(passwordField.getText(), invalidFieldLabel7);
        firstPassword = validateDetails.checkTotalErrors(error1, error2, error3, firstPassword,passwordField.getText());
        System.out.println("First Password: " + firstPassword);

        //validate password again 
        error1 = validateDetails.checkFieldEmpty(passwordConfirmationField.getText().isEmpty(), invalidFieldLabel8);
        error2 = validateDetails.checkContentsAreStrings(passwordConfirmationField.getText().matches("^[A-Za-z0-9@!#$&-_]*$"), invalidFieldLabel8);
        error3 = validateDetails.checkPasswordCharacterRange(passwordConfirmationField.getText(), invalidFieldLabel8);
        confirmPassword = validateDetails.checkTotalErrors(error1, error2, error3, confirmPassword,passwordConfirmationField.getText()); 
        System.out.println("Confirm Password: " + confirmPassword);

        //check if the two passwords match
        error1 = validateDetails.checkPasswordsMatch(firstPassword, confirmPassword, invalidFieldLabel8);
        System.out.println("Errors occured in password matching: " + error1);
        password = validateDetails.checkTotalErrors(error1, password, confirmPassword);
        System.out.println("Final Password: " + password);
        
        
        //test
        System.out.println(firstName + "," + lastName + "," + emailAddress + "," 
                         + contactNumber + "," + password);
        
        
        if (firstName != null  &&  lastName !=null  &&  emailAddress != null  
            &&  contactNumber != null  &&  password != null)
        {
            //add user details to AccountDetails.txt
            modifyDetails.addUserDetails(ACCOUNT_DETAILS_PATH, firstName, lastName, emailAddress,
            contactNumber, password);
            System.out.println("Added User Details Successfully!");

            //close window
            this.dispose();
        } 

        else 
        {
            System.out.println("FILE WRITING UNSUCCESSFUL!!!");
        }
    }//GEN-LAST:event_completeRegistrationButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void accountTypeFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_accountTypeFieldActionPerformed
    }//GEN-LAST:event_accountTypeFieldActionPerformed

    private void initialDepositFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_initialDepositFieldActionPerformed
    }//GEN-LAST:event_initialDepositFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> accountTypeField;
    private javax.swing.JButton cancelButton;
    public javax.swing.JLabel chooseAccountLabel;
    private javax.swing.JButton completeRegistrationButton;
    private javax.swing.JTextField emailAddressField;
    private javax.swing.JLabel emptyFieldLabel3;
    private javax.swing.JTextField firstNameField;
    private javax.swing.JTextField initialDepositField;
    private javax.swing.JLabel initialDepositLabel;
    public javax.swing.JLabel invalidFieldLabel1;
    public javax.swing.JLabel invalidFieldLabel2;
    public javax.swing.JLabel invalidFieldLabel3;
    public javax.swing.JLabel invalidFieldLabel4;
    public javax.swing.JLabel invalidFieldLabel5;
    public javax.swing.JLabel invalidFieldLabel6;
    public javax.swing.JLabel invalidFieldLabel7;
    public javax.swing.JLabel invalidFieldLabel8;
    public javax.swing.JLabel invalidFieldLabel9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelConfirmPassword;
    private javax.swing.JLabel jLabelContactNum1;
    private javax.swing.JLabel jLabelContactNum2;
    private javax.swing.JLabel jLabelEmailAddress;
    private javax.swing.JLabel jLabelLastName;
    private javax.swing.JLabel jLabelPassword;
    private javax.swing.JLabel jLabelPasswordMatch;
    private javax.swing.JLabel jLabelUsername;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField lastNameField;
    private javax.swing.JPasswordField passwordConfirmationField;
    private javax.swing.JPasswordField passwordField;
    private javax.swing.JTextField primaryContactNumberField;
    private javax.swing.JTextField secondaryContactNumberField;
    private javax.swing.JTextField usernameField;
    // End of variables declaration//GEN-END:variables
}
